#   pyRCV2: Preferential vote counting
#   Copyright © 2020  Lee Yingtong Li (RunasSudo)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Native:
	"""
	Wrapper for JS numbers (naive floating-point arithmetic)
	"""
	
	ROUND_DOWN = 0
	ROUND_HALF_UP = 1
	ROUND_HALF_EVEN = 2
	ROUND_UP = 3
	
	def __init__(self, val):
		if isinstance(val, Native):
			self.impl = val.impl
		else:
			self.impl = parseFloat(val)
	
	def pp(self, dp):
		"""Pretty print to specified number of decimal places"""
		return self.impl.toFixed(dp)
	
	def to_rational(self):
		"""Convert to an instance of Rational"""
		from pyRCV2.numbers import Rational
		return Rational(self.impl)
	
	def __add__(self, other):
		return Native(self.impl + other.impl)
	def __sub__(self, other):
		return Native(self.impl - other.impl)
	def __mul__(self, other):
		return Native(self.impl * other.impl)
	def __div__(self, other):
		return Native(self.impl / other.impl)
	
	def __eq__(self, other):
		return self.impl == other.impl
	def __gt__(self, other):
		return self.impl > other.impl
	def __ge__(self, other):
		return self.impl >= other.impl
	def __lt__(self, other):
		return self.impl < other.impl
	def __le__(self, other):
		return self.impl <= other.impl
	
	def __floor__(self):
		return Native(Math.floor(self.impl))
	
	def round(self, dps, mode):
		"""Round to the specified number of decimal places, using the ROUND_* mode specified"""
		if mode == Native.ROUND_DOWN:
			return Native(Math.floor(self.impl * Math.pow(10, dps)) / Math.pow(10, dps))
		elif mode == Native.ROUND_HALF_UP:
			return Native(Math.round(self.impl * Math.pow(10, dps)) / Math.pow(10, dps))
		elif mode == Native.ROUND_HALF_EVEN:
			raise Exception('ROUND_HALF_EVEN is not implemented in JS Native context')
		elif mode == Native.ROUND_UP:
			return Native(Math.ceil(self.impl * Math.pow(10, dps)) / Math.pow(10, dps))
		else:
			raise Exception('Invalid rounding mode')
